'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

var _openpgp = require('openpgp');

var openpgp = _interopRequireWildcard(_openpgp);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ConversationsFetcher = function () {
    function ConversationsFetcher(cookie, sessionId, privateKey, logger) {
        _classCallCheck(this, ConversationsFetcher);

        this._headers = {
            cookie: cookie,
            'x-pm-apiversion': '1',
            'x-pm-appversion': 'Web_3.5.12',
            'x-pm-session': sessionId
        };
        this._privateKey = privateKey;
        this._logger = logger;
        this._counts = null;
    }

    _createClass(ConversationsFetcher, [{
        key: 'getConversationsInPageWithLabel',
        value: function () {
            var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(page, label) {
                var url, result, convList;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                url = ConversationsFetcher.BASE_URL + '/conversations?Label=' + label + '&Limit=100&Page=' + page;
                                _context.next = 3;
                                return (0, _nodeFetch2.default)(url, { headers: this._headers });

                            case 3:
                                result = _context.sent;
                                _context.next = 6;
                                return result.json();

                            case 6:
                                convList = _context.sent;
                                return _context.abrupt('return', convList.Conversations);

                            case 8:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function getConversationsInPageWithLabel(_x, _x2) {
                return _ref.apply(this, arguments);
            }

            return getConversationsInPageWithLabel;
        }()
    }, {
        key: 'getConversationsCountForLabel',
        value: function () {
            var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(label) {
                var url, result;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                if (this._counts) {
                                    _context2.next = 10;
                                    break;
                                }

                                url = ConversationsFetcher.BASE_URL + '/conversations/count';
                                _context2.next = 4;
                                return (0, _nodeFetch2.default)(url, { headers: this._headers });

                            case 4:
                                result = _context2.sent;
                                _context2.next = 7;
                                return result.json();

                            case 7:
                                _context2.t0 = function (acc, c) {
                                    return _extends({}, acc, _defineProperty({}, c.LabelID, c.Total));
                                };

                                _context2.t1 = {};
                                this._counts = _context2.sent.Counts.reduce(_context2.t0, _context2.t1);

                            case 10:
                                return _context2.abrupt('return', this._counts[label]);

                            case 11:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function getConversationsCountForLabel(_x3) {
                return _ref2.apply(this, arguments);
            }

            return getConversationsCountForLabel;
        }()
    }, {
        key: 'getConversationsWithLabel',
        value: function () {
            var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3(label) {
                var conversations, conversationsCount, page;
                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                conversations = [];
                                _context3.next = 3;
                                return this.getConversationsCountForLabel(label);

                            case 3:
                                conversationsCount = _context3.sent;

                                this._logger(conversationsCount + ' conversations to fetch for label ' + label + '.');
                                page = 0;

                            case 6:
                                if (!(page < conversationsCount / 100 + 1)) {
                                    _context3.next = 18;
                                    break;
                                }

                                this._logger('Fetching conversations in page ' + page + '...');
                                _context3.t0 = conversations.push;
                                _context3.t1 = conversations;
                                _context3.next = 12;
                                return this.getConversationsInPageWithLabel(page, label);

                            case 12:
                                _context3.t2 = _context3.sent;
                                _context3.t3 = _toConsumableArray(_context3.t2);

                                _context3.t0.apply.call(_context3.t0, _context3.t1, _context3.t3);

                            case 15:
                                page++;
                                _context3.next = 6;
                                break;

                            case 18:
                                return _context3.abrupt('return', conversations);

                            case 19:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this);
            }));

            function getConversationsWithLabel(_x4) {
                return _ref3.apply(this, arguments);
            }

            return getConversationsWithLabel;
        }()
    }, {
        key: 'getConversations',
        value: function () {
            var _ref4 = _asyncToGenerator(regeneratorRuntime.mark(function _callee4() {
                var conversations, labels, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, label;

                return regeneratorRuntime.wrap(function _callee4$(_context4) {
                    while (1) {
                        switch (_context4.prev = _context4.next) {
                            case 0:
                                conversations = [];
                                labels = [0, 2, 6];
                                _iteratorNormalCompletion = true;
                                _didIteratorError = false;
                                _iteratorError = undefined;
                                _context4.prev = 5;
                                _iterator = labels[Symbol.iterator]();

                            case 7:
                                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                                    _context4.next = 20;
                                    break;
                                }

                                label = _step.value;

                                this._logger('Fetching conversations for label ' + label + '...');
                                _context4.t0 = conversations.push;
                                _context4.t1 = conversations;
                                _context4.next = 14;
                                return this.getConversationsWithLabel(label);

                            case 14:
                                _context4.t2 = _context4.sent;
                                _context4.t3 = _toConsumableArray(_context4.t2);

                                _context4.t0.apply.call(_context4.t0, _context4.t1, _context4.t3);

                            case 17:
                                _iteratorNormalCompletion = true;
                                _context4.next = 7;
                                break;

                            case 20:
                                _context4.next = 26;
                                break;

                            case 22:
                                _context4.prev = 22;
                                _context4.t4 = _context4['catch'](5);
                                _didIteratorError = true;
                                _iteratorError = _context4.t4;

                            case 26:
                                _context4.prev = 26;
                                _context4.prev = 27;

                                if (!_iteratorNormalCompletion && _iterator.return) {
                                    _iterator.return();
                                }

                            case 29:
                                _context4.prev = 29;

                                if (!_didIteratorError) {
                                    _context4.next = 32;
                                    break;
                                }

                                throw _iteratorError;

                            case 32:
                                return _context4.finish(29);

                            case 33:
                                return _context4.finish(26);

                            case 34:
                                return _context4.abrupt('return', conversations);

                            case 35:
                            case 'end':
                                return _context4.stop();
                        }
                    }
                }, _callee4, this, [[5, 22, 26, 34], [27,, 29, 33]]);
            }));

            function getConversations() {
                return _ref4.apply(this, arguments);
            }

            return getConversations;
        }()
    }, {
        key: 'populateConversation',
        value: function () {
            var _ref5 = _asyncToGenerator(regeneratorRuntime.mark(function _callee5(conversation) {
                var url, result, newConversation;
                return regeneratorRuntime.wrap(function _callee5$(_context5) {
                    while (1) {
                        switch (_context5.prev = _context5.next) {
                            case 0:
                                this._logger('Populating conversation ' + conversation.ID + '...');
                                url = ConversationsFetcher.BASE_URL + '/conversations/' + conversation.ID;
                                _context5.next = 4;
                                return (0, _nodeFetch2.default)(url, { headers: this._headers });

                            case 4:
                                result = _context5.sent;
                                _context5.next = 7;
                                return result.json();

                            case 7:
                                newConversation = _context5.sent;

                                Object.assign(conversation, newConversation.Conversation, { Messages: newConversation.Messages });
                                return _context5.abrupt('return', conversation);

                            case 10:
                            case 'end':
                                return _context5.stop();
                        }
                    }
                }, _callee5, this);
            }));

            function populateConversation(_x5) {
                return _ref5.apply(this, arguments);
            }

            return populateConversation;
        }()
    }, {
        key: 'getMessagesFromConversation',
        value: function () {
            var _ref6 = _asyncToGenerator(regeneratorRuntime.mark(function _callee6(conversation) {
                var _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, message;

                return regeneratorRuntime.wrap(function _callee6$(_context6) {
                    while (1) {
                        switch (_context6.prev = _context6.next) {
                            case 0:
                                _iteratorNormalCompletion2 = true;
                                _didIteratorError2 = false;
                                _iteratorError2 = undefined;
                                _context6.prev = 3;
                                _iterator2 = conversation.Messages[Symbol.iterator]();

                            case 5:
                                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                                    _context6.next = 16;
                                    break;
                                }

                                message = _step2.value;

                                if (message.Body) {
                                    _context6.next = 10;
                                    break;
                                }

                                _context6.next = 10;
                                return this.populateMessage(message);

                            case 10:
                                if (message.BodyDecrypted) {
                                    _context6.next = 13;
                                    break;
                                }

                                _context6.next = 13;
                                return this.decryptMessageBody(message);

                            case 13:
                                _iteratorNormalCompletion2 = true;
                                _context6.next = 5;
                                break;

                            case 16:
                                _context6.next = 22;
                                break;

                            case 18:
                                _context6.prev = 18;
                                _context6.t0 = _context6['catch'](3);
                                _didIteratorError2 = true;
                                _iteratorError2 = _context6.t0;

                            case 22:
                                _context6.prev = 22;
                                _context6.prev = 23;

                                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                                    _iterator2.return();
                                }

                            case 25:
                                _context6.prev = 25;

                                if (!_didIteratorError2) {
                                    _context6.next = 28;
                                    break;
                                }

                                throw _iteratorError2;

                            case 28:
                                return _context6.finish(25);

                            case 29:
                                return _context6.finish(22);

                            case 30:
                                return _context6.abrupt('return', conversation.Messages);

                            case 31:
                            case 'end':
                                return _context6.stop();
                        }
                    }
                }, _callee6, this, [[3, 18, 22, 30], [23,, 25, 29]]);
            }));

            function getMessagesFromConversation(_x6) {
                return _ref6.apply(this, arguments);
            }

            return getMessagesFromConversation;
        }()
    }, {
        key: 'populateMessage',
        value: function () {
            var _ref7 = _asyncToGenerator(regeneratorRuntime.mark(function _callee7(message) {
                var url, result, newMessage;
                return regeneratorRuntime.wrap(function _callee7$(_context7) {
                    while (1) {
                        switch (_context7.prev = _context7.next) {
                            case 0:
                                url = ConversationsFetcher.BASE_URL + '/messages/' + message.ID;
                                _context7.next = 3;
                                return (0, _nodeFetch2.default)(url, { headers: this._headers });

                            case 3:
                                result = _context7.sent;
                                _context7.next = 6;
                                return result.json();

                            case 6:
                                newMessage = _context7.sent;

                                Object.assign(message, newMessage.Message);

                            case 8:
                            case 'end':
                                return _context7.stop();
                        }
                    }
                }, _callee7, this);
            }));

            function populateMessage(_x7) {
                return _ref7.apply(this, arguments);
            }

            return populateMessage;
        }()
    }, {
        key: 'decryptMessageBody',
        value: function () {
            var _ref8 = _asyncToGenerator(regeneratorRuntime.mark(function _callee8(message) {
                var messageBody;
                return regeneratorRuntime.wrap(function _callee8$(_context8) {
                    while (1) {
                        switch (_context8.prev = _context8.next) {
                            case 0:
                                _context8.prev = 0;
                                _context8.next = 3;
                                return openpgp.decrypt({
                                    message: openpgp.message.readArmored(message.Body),
                                    privateKey: this._privateKey
                                });

                            case 3:
                                messageBody = _context8.sent;

                                message.BodyDecrypted = messageBody.data;
                                _context8.next = 9;
                                break;

                            case 7:
                                _context8.prev = 7;
                                _context8.t0 = _context8['catch'](0);

                            case 9:
                                return _context8.abrupt('return', message);

                            case 10:
                            case 'end':
                                return _context8.stop();
                        }
                    }
                }, _callee8, this, [[0, 7]]);
            }));

            function decryptMessageBody(_x8) {
                return _ref8.apply(this, arguments);
            }

            return decryptMessageBody;
        }()
    }]);

    return ConversationsFetcher;
}();

ConversationsFetcher.BASE_URL = 'https://mail.protonmail.com/api';
exports.default = ConversationsFetcher;