'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fsPromise = require('fs-promise');

var _fsPromise2 = _interopRequireDefault(_fsPromise);

var _ConversationFetcher = require('./ConversationFetcher');

var _ConversationFetcher2 = _interopRequireDefault(_ConversationFetcher);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Exporter = function () {
    function Exporter(conversationFetcher, logger) {
        _classCallCheck(this, Exporter);

        this.conversationFetcher = conversationFetcher;
        this._logger = logger;
    }

    _createClass(Exporter, [{
        key: 'exportEmails',
        value: function () {
            var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(outputDirectory) {
                var conversations, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, conversation, messages, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, message, messageString;

                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                _context.next = 2;
                                return this.conversationFetcher.getConversations();

                            case 2:
                                conversations = _context.sent;
                                _iteratorNormalCompletion = true;
                                _didIteratorError = false;
                                _iteratorError = undefined;
                                _context.prev = 6;
                                _iterator = conversations[Symbol.iterator]();

                            case 8:
                                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                                    _context.next = 46;
                                    break;
                                }

                                conversation = _step.value;

                                this._logger('Exporting conversation ' + conversation.ID + '...');
                                _context.next = 13;
                                return this.conversationFetcher.populateConversation(conversation);

                            case 13:
                                _context.next = 15;
                                return this.conversationFetcher.getMessagesFromConversation(conversation);

                            case 15:
                                messages = _context.sent;
                                _iteratorNormalCompletion2 = true;
                                _didIteratorError2 = false;
                                _iteratorError2 = undefined;
                                _context.prev = 19;
                                _iterator2 = messages[Symbol.iterator]();

                            case 21:
                                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                                    _context.next = 29;
                                    break;
                                }

                                message = _step2.value;
                                messageString = this._getFullDecryptedMessageAsString(message);
                                _context.next = 26;
                                return _fsPromise2.default.writeFile(outputDirectory + '/' + message.ID + '.eml', messageString);

                            case 26:
                                _iteratorNormalCompletion2 = true;
                                _context.next = 21;
                                break;

                            case 29:
                                _context.next = 35;
                                break;

                            case 31:
                                _context.prev = 31;
                                _context.t0 = _context['catch'](19);
                                _didIteratorError2 = true;
                                _iteratorError2 = _context.t0;

                            case 35:
                                _context.prev = 35;
                                _context.prev = 36;

                                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                                    _iterator2.return();
                                }

                            case 38:
                                _context.prev = 38;

                                if (!_didIteratorError2) {
                                    _context.next = 41;
                                    break;
                                }

                                throw _iteratorError2;

                            case 41:
                                return _context.finish(38);

                            case 42:
                                return _context.finish(35);

                            case 43:
                                _iteratorNormalCompletion = true;
                                _context.next = 8;
                                break;

                            case 46:
                                _context.next = 52;
                                break;

                            case 48:
                                _context.prev = 48;
                                _context.t1 = _context['catch'](6);
                                _didIteratorError = true;
                                _iteratorError = _context.t1;

                            case 52:
                                _context.prev = 52;
                                _context.prev = 53;

                                if (!_iteratorNormalCompletion && _iterator.return) {
                                    _iterator.return();
                                }

                            case 55:
                                _context.prev = 55;

                                if (!_didIteratorError) {
                                    _context.next = 58;
                                    break;
                                }

                                throw _iteratorError;

                            case 58:
                                return _context.finish(55);

                            case 59:
                                return _context.finish(52);

                            case 60:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this, [[6, 48, 52, 60], [19, 31, 35, 43], [36,, 38, 42], [53,, 55, 59]]);
            }));

            function exportEmails(_x) {
                return _ref.apply(this, arguments);
            }

            return exportEmails;
        }()
    }, {
        key: '_getHeaderFromMessage',
        value: function _getHeaderFromMessage(message) {
            var header = message.Header.replace(/\r?\n\t/gm, '');
            if (header.match(/Content-type:/i)) {
                return header.replace(/Content-Type: (.*)/i, 'Content-type: ' + message.MIMEType + '; charset=UTF-8');
            } else {
                return header.replace(/(\n+)$/m, '\nContent-type: ' + message.MIMEType + '; charset=UTF-8$1');
            }
        }
    }, {
        key: '_getFullDecryptedMessageAsString',
        value: function _getFullDecryptedMessageAsString(message) {
            var header = this._getHeaderFromMessage(message);
            return header + '\n' + message.BodyDecrypted;
        }
    }]);

    return Exporter;
}();

exports.default = Exporter;